#ifndef ASSIGNMENT_H
#define ASSIGNMENT_H
#include "data.h"

static unsigned short assignments_hack = 0xeeee;

GSM_API struct assignment *alloc_assignment();
GSM_API struct assignment **alloc_assignments(unsigned short);
GSM_API void cleanup_assignments(unsigned short, struct assignment **);
GSM_API int find_assignments(struct gsm *);
GSM_API int parse_assignment(struct gsm *, unsigned short, struct assignment *, unsigned short);
GSM_API int write_assignments(struct gsm *);
GSM_API int reassign_kid_to_swt(struct gsm *);
GSM_API int reassign_tac_to_swt(struct gsm *);
GSM_API int reassign_bf1_to_swt(struct gsm *);
GSM_API int reassign_swt_to_kid(struct gsm *);
GSM_API int reassign_tac_to_kid(struct gsm *);
GSM_API int reassign_bf1_to_kid(struct gsm *);
GSM_API int reassign_swt_to_tac(struct gsm *);
GSM_API int reassign_kid_to_tac(struct gsm *);
GSM_API int reassign_swt_to_bf1(struct gsm *);
GSM_API int reassign_kid_to_bf1(struct gsm *);
GSM_API int reassign_tac_to_bf1(struct gsm *);
GSM_API unsigned int get_assignments_by_bone(struct gsm *, unsigned short);
GSM_API int get_bone_by_position(struct gsm *, unsigned short);
GSM_API int assign_bones(struct gsm *);
GSM_API int describe_assignments(struct gsm *);

/* a "vertex" is really what the GSM people call a position */
struct assignment {
  unsigned short bone_id;
  off_t offset;
  unsigned short first_vertex;
  unsigned short num_vertices;
  unsigned short unknown;
};

#endif
