#ifndef BIPED_H
#define BIPED_H

GSM_API char *get_biped_bone_name(unsigned short, unsigned short);
GSM_API int reassign_bone_id(int, int, unsigned short);
GSM_API int reassign_bone_id_swt(int, unsigned short);
GSM_API int reassign_bone_id_kid(int, unsigned short);
GSM_API int reassign_bone_id_tac(int, unsigned short);
GSM_API int reassign_bone_id_bf1(int, unsigned short);
GSM_API int reassign_bone_id_swt_to_kid(unsigned short);
GSM_API int reassign_bone_id_swt_to_tac(unsigned short);
GSM_API int reassign_bone_id_swt_to_bf1(unsigned short);
GSM_API int reassign_bone_id_kid_to_swt(unsigned short);
GSM_API int reassign_bone_id_kid_to_tac(unsigned short);
GSM_API int reassign_bone_id_kid_to_bf1(unsigned short);
GSM_API int reassign_bone_id_tac_to_swt(unsigned short);
GSM_API int reassign_bone_id_tac_to_kid(unsigned short);
GSM_API int reassign_bone_id_tac_to_bf1(unsigned short);
GSM_API int reassign_bone_id_bf1_to_swt(unsigned short);
GSM_API int reassign_bone_id_bf1_to_kid(unsigned short);

/* bone names */
#define BIPED_PELVIS "Biped Pelvis"
#define BIPED_SPINE "Biped Spine"
#define BIPED_SPINE1 "Biped Spine1"
#define BIPED_SPINE2 "Biped Spine2"
#define BIPED_NECK "Biped Neck"
#define BIPED_HEAD "Biped Head"
#define BIPED_PONYTAIL1 "Biped Ponytail1"
#define BIPED_PONYTAIL11 "Biped Ponytail11"
#define BIPED_PONYTAIL12 "Biped Ponytail12"
#define BIPED_PONYTAIL2 "Biped Ponytail2"
#define BIPED_PONYTAIL21 "Biped Ponytail21"
#define BIPED_PONYTAIL22 "Biped Ponytail22"
#define BIPED_L_CLAVICLE "Biped L Clavicle"
#define BIPED_L_UPPERARM "Biped L UpperArm"
#define BIPED_L_FOREARM "Biped L Forearm"
#define BIPED_L_HAND "Biped L Hand"
#define BIPED_L_FINGER0 "Biped L Finger0"
#define BIPED_L_FINGER01 "Biped L Finger01"
#define BIPED_L_FINGER02 "Biped L Finger02"
#define BIPED_L_FINGER1 "Biped L Finger1"
#define BIPED_L_FINGER11 "Biped L Finger11"
#define BIPED_L_FINGER12 "Biped L Finger12"
#define BIPED_L_FINGER2 "Biped L Finger2"
#define BIPED_L_FINGER21 "Biped L Finger21"
#define BIPED_L_FINGER22 "Biped L Finger22"
#define BIPED_L_FINGER3 "Biped L Finger3"
#define BIPED_L_FINGER31 "Biped L Finger31"
#define BIPED_L_FINGER32 "Biped L Finger32"
#define BIPED_L_FINGER4 "Biped L Finger4"
#define BIPED_L_FINGER41 "Biped L Finger41"
#define BIPED_L_FINGER42 "Biped L Finger42"
#define BIPED_R_CLAVICLE "Biped R Clavicle"
#define BIPED_R_UPPERARM "Biped R UpperArm"
#define BIPED_R_FOREARM "Biped R Forearm"
#define BIPED_R_HAND "Biped R Hand"
#define BIPED_R_FINGER0 "Biped R Finger0"
#define BIPED_R_FINGER01 "Biped R Finger01"
#define BIPED_R_FINGER02 "Biped R Finger02"
#define BIPED_R_FINGER1 "Biped R Finger1"
#define BIPED_R_FINGER11 "Biped R Finger11"
#define BIPED_R_FINGER12 "Biped R Finger12"
#define BIPED_R_FINGER2 "Biped R Finger2"
#define BIPED_R_FINGER21 "Biped R Finger21"
#define BIPED_R_FINGER22 "Biped R Finger22"
#define BIPED_R_FINGER3 "Biped R Finger3"
#define BIPED_R_FINGER31 "Biped R Finger31"
#define BIPED_R_FINGER32 "Biped R Finger32"
#define BIPED_R_FINGER4 "Biped R Finger4"
#define BIPED_R_FINGER41 "Biped R Finger41"
#define BIPED_R_FINGER42 "Biped R Finger42"
#define BIPED_L_THIGH "Biped L Thigh"
#define BIPED_L_CALF "Biped L Calf"
#define BIPED_L_FOOT "Biped L Foot"
#define BIPED_L_TOE0 "Biped L Toe0"
#define BIPED_R_THIGH "Biped R Thigh"
#define BIPED_R_CALF "Biped R Calf"
#define BIPED_R_FOOT "Biped R Foot"
#define BIPED_R_TOE0 "Biped R Toe0"

/* SWT model with 52 bones */
#define SWT_BIPED_NUM_SKELETONS 1
#define SWT_BIPED_NUM_BONES 52
#define SWT_BIPED_NAME "SwatGuy"
#define SWT_BIPED_PELVIS 0
#define SWT_BIPED_SPINE 1
#define SWT_BIPED_SPINE1 2
#define SWT_BIPED_SPINE2 3
#define SWT_BIPED_NECK 4
#define SWT_BIPED_HEAD 5
#define SWT_BIPED_L_CLAVICLE 6
#define SWT_BIPED_L_UPPERARM 7
#define SWT_BIPED_L_FOREARM 8
#define SWT_BIPED_L_HAND 9
#define SWT_BIPED_L_FINGER0 10
#define SWT_BIPED_L_FINGER01 11
#define SWT_BIPED_L_FINGER02 12
#define SWT_BIPED_L_FINGER1 13
#define SWT_BIPED_L_FINGER11 14
#define SWT_BIPED_L_FINGER12 15
#define SWT_BIPED_L_FINGER2 16
#define SWT_BIPED_L_FINGER21 17
#define SWT_BIPED_L_FINGER22 18
#define SWT_BIPED_L_FINGER3 19
#define SWT_BIPED_L_FINGER31 20
#define SWT_BIPED_L_FINGER32 21
#define SWT_BIPED_L_FINGER4 22
#define SWT_BIPED_L_FINGER41 23
#define SWT_BIPED_L_FINGER42 24
#define SWT_BIPED_R_CLAVICLE 25
#define SWT_BIPED_R_UPPERARM 26
#define SWT_BIPED_R_FOREARM 27
#define SWT_BIPED_R_HAND 28
#define SWT_BIPED_R_FINGER0 29
#define SWT_BIPED_R_FINGER01 30
#define SWT_BIPED_R_FINGER02 31
#define SWT_BIPED_R_FINGER1 32
#define SWT_BIPED_R_FINGER11 33
#define SWT_BIPED_R_FINGER12 34
#define SWT_BIPED_R_FINGER2 35
#define SWT_BIPED_R_FINGER21 36
#define SWT_BIPED_R_FINGER22 37
#define SWT_BIPED_R_FINGER3 38
#define SWT_BIPED_R_FINGER31 39
#define SWT_BIPED_R_FINGER32 40
#define SWT_BIPED_R_FINGER4 41
#define SWT_BIPED_R_FINGER41 42
#define SWT_BIPED_R_FINGER42 43
#define SWT_BIPED_L_THIGH 44
#define SWT_BIPED_L_CALF 45
#define SWT_BIPED_L_FOOT 46
#define SWT_BIPED_L_TOE0 47
#define SWT_BIPED_R_THIGH 48
#define SWT_BIPED_R_CALF 49
#define SWT_BIPED_R_FOOT 50
#define SWT_BIPED_R_TOE0 51

/* KID models with 40 bones */
#define KID_BIPED_NUM_SKELETONS 1
#define KID_BIPED_NUM_BONES 40
#define KID_BIPED_NAME "SwatGuy"
#define KID_BIPED_PELVIS 0
#define KID_BIPED_SPINE 1
#define KID_BIPED_SPINE1 2
#define KID_BIPED_SPINE2 3
#define KID_BIPED_NECK 4
#define KID_BIPED_HEAD 5
#define KID_BIPED_PONYTAIL1 6
#define KID_BIPED_PONYTAIL11 7
#define KID_BIPED_PONYTAIL12 8
#define KID_BIPED_PONYTAIL2 9
#define KID_BIPED_PONYTAIL21 10
#define KID_BIPED_PONYTAIL22 11
#define KID_BIPED_L_CLAVICLE 12
#define KID_BIPED_L_UPPERARM 13
#define KID_BIPED_L_FOREARM 14
#define KID_BIPED_L_HAND 15
#define KID_BIPED_L_FINGER0 16
#define KID_BIPED_L_FINGER01 17
#define KID_BIPED_L_FINGER1 18
#define KID_BIPED_L_FINGER11 19
#define KID_BIPED_L_FINGER2 20
#define KID_BIPED_L_FINGER21 21
#define KID_BIPED_R_CLAVICLE 22
#define KID_BIPED_R_UPPERARM 23
#define KID_BIPED_R_FOREARM 24
#define KID_BIPED_R_HAND 25
#define KID_BIPED_R_FINGER0 26
#define KID_BIPED_R_FINGER01 27
#define KID_BIPED_R_FINGER1 28
#define KID_BIPED_R_FINGER11 29
#define KID_BIPED_R_FINGER2 30
#define KID_BIPED_R_FINGER21 31
#define KID_BIPED_L_THIGH 32
#define KID_BIPED_L_CALF 33
#define KID_BIPED_L_FOOT 34
#define KID_BIPED_L_TOE0 35
#define KID_BIPED_R_THIGH 36
#define KID_BIPED_R_CALF 37
#define KID_BIPED_R_FOOT 38
#define KID_BIPED_R_TOE0 39

/* TAC, BGx and MHx models with 37 bones */
#define TAC_BIPED_NUM_SKELETONS 1
#define TAC_BIPED_NUM_BONES 37
#define TAC_BIPED_NAME "SwatGuy"
#define TAC_BIPED_PELVIS 0
#define TAC_BIPED_SPINE 1
#define TAC_BIPED_SPINE1 2
#define TAC_BIPED_SPINE2 3
#define TAC_BIPED_NECK 4
#define TAC_BIPED_HEAD 5
#define TAC_BIPED_PONYTAIL1 6
#define TAC_BIPED_PONYTAIL11 7
#define TAC_BIPED_PONYTAIL12 8
#define TAC_BIPED_L_CLAVICLE 9
#define TAC_BIPED_L_UPPERARM 10
#define TAC_BIPED_L_FOREARM 11
#define TAC_BIPED_L_HAND 12
#define TAC_BIPED_L_FINGER0 13
#define TAC_BIPED_L_FINGER01 14
#define TAC_BIPED_L_FINGER1 15
#define TAC_BIPED_L_FINGER11 16
#define TAC_BIPED_L_FINGER2 17
#define TAC_BIPED_L_FINGER21 18
#define TAC_BIPED_R_CLAVICLE 19
#define TAC_BIPED_R_UPPERARM 20
#define TAC_BIPED_R_FOREARM 21
#define TAC_BIPED_R_HAND 22
#define TAC_BIPED_R_FINGER0 23
#define TAC_BIPED_R_FINGER01 24
#define TAC_BIPED_R_FINGER1 25
#define TAC_BIPED_R_FINGER11 26
#define TAC_BIPED_R_FINGER2 27
#define TAC_BIPED_R_FINGER21 28
#define TAC_BIPED_L_THIGH 29
#define TAC_BIPED_L_CALF 30
#define TAC_BIPED_L_FOOT 31
#define TAC_BIPED_L_TOE0 32
#define TAC_BIPED_R_THIGH 33
#define TAC_BIPED_R_CALF 34
#define TAC_BIPED_R_FOOT 35
#define TAC_BIPED_R_TOE0 36

/* BF1, FHx and PRH models with 34 bones */
#define BF1_BIPED_NUM_SKELETONS 1
#define BF1_BIPED_NUM_BONES 34
#define BF1_BIPED_NAME "SwatGuy"
#define BF1_BIPED_PELVIS 0
#define BF1_BIPED_SPINE 1
#define BF1_BIPED_SPINE1 2
#define BF1_BIPED_SPINE2 3
#define BF1_BIPED_NECK 4
#define BF1_BIPED_HEAD 5
#define BF1_BIPED_L_CLAVICLE 6
#define BF1_BIPED_L_UPPERARM 7
#define BF1_BIPED_L_FOREARM 8
#define BF1_BIPED_L_HAND 9
#define BF1_BIPED_L_FINGER0 10
#define BF1_BIPED_L_FINGER01 11
#define BF1_BIPED_L_FINGER1 12
#define BF1_BIPED_L_FINGER11 13
#define BF1_BIPED_L_FINGER2 14
#define BF1_BIPED_L_FINGER21 15
#define BF1_BIPED_R_CLAVICLE 16
#define BF1_BIPED_R_UPPERARM 17
#define BF1_BIPED_R_FOREARM 18
#define BF1_BIPED_R_HAND 19
#define BF1_BIPED_R_FINGER0 20
#define BF1_BIPED_R_FINGER01 21
#define BF1_BIPED_R_FINGER1 22
#define BF1_BIPED_R_FINGER11 23
#define BF1_BIPED_R_FINGER2 24
#define BF1_BIPED_R_FINGER21 25
#define BF1_BIPED_L_THIGH 26
#define BF1_BIPED_L_CALF 27
#define BF1_BIPED_L_FOOT 28
#define BF1_BIPED_L_TOE0 29
#define BF1_BIPED_R_THIGH 30
#define BF1_BIPED_R_CALF 31
#define BF1_BIPED_R_FOOT 32
#define BF1_BIPED_R_TOE0 33

char *get_biped_bone_name(unsigned short, unsigned short);

#endif
