#ifndef DEBUG_H
#define DEBUG_H
#include <stdio.h>

GSM_API void dbg(char *, ...);
GSM_API void error_dbg(char *, ...);
GSM_API void INFO(char *, ...);
GSM_API void SAY(char *, ...);

GSM_API int gsm_debug, gsm_quiet, gsm_verbose;
GSM_API FILE *gsm_error;
GSM_API char gsm_buffer[4096];

#ifdef _MSC_VER
/* Visual C++ */
#define DEBUG if (gsm_debug) dbg("DEBUG: "), dbg
#define TRACE if (gsm_debug && gsm_verbose) dbg("TRACE: "), dbg
#define TRACE1 if (gsm_debug && gsm_verbose > 1) dbg("  MEM: "), dbg
#define TRACE2 if (gsm_debug && gsm_verbose > 2) dbg("  MEM: "), dbg
#define ERROR dbg("ERROR: "), error_dbg
#else
#define DEBUG if (gsm_debug) dbg("DEBUG: %s(): %s:%d: ", __FUNCTION__, __FILE__, __LINE__), dbg
#define TRACE if (gsm_debug && gsm_verbose) dbg("TRACE: %s(): %s:%d: ", __FUNCTION__, __FILE__, __LINE__), dbg
#define TRACE1 if (gsm_debug && gsm_verbose > 1) dbg("  MEM: %s(): %s:%d: ", __FUNCTION__, __FILE__, __LINE__), dbg
#define TRACE2 if (gsm_debug && gsm_verbose > 2) dbg("  MEM: %s(): %s:%d: ", __FUNCTION__, __FILE__, __LINE__), dbg
#define ERROR dbg("ERROR: %s(): %s:%d: ", __FUNCTION__, __FILE__, __LINE__), error_dbg
#endif
#define WARN dbg("WARNING: "), error_dbg

#endif
