#ifndef FILE_H
#define FILE_H
#include <stdio.h>
#include <sys/types.h>
#ifdef _MSC_VER
#include <ctype.h>
#define read_string sscanf
#endif

GSM_API FILE *open_read(char *);
GSM_API FILE *open_write(char *);
GSM_API unsigned int get_file_position(FILE *);
GSM_API int skip(FILE *, unsigned int);
GSM_API size_t try_read(FILE *, void *, size_t);
GSM_API int read_char(FILE *, char *);
GSM_API int read_unsigned_char(FILE *, unsigned char *);
GSM_API int read_short(FILE *, unsigned short *);
GSM_API int read_int(FILE *, unsigned int *);
GSM_API int read_float(FILE *, float *);
GSM_API int read_arbitrary(FILE *, void *, unsigned int);
GSM_API int read_line(FILE *, char *, size_t);
GSM_API size_t try_write(FILE *, void *, size_t);
GSM_API int write_char(FILE *, char *);
GSM_API int write_unsigned_char(FILE *, unsigned char *);
GSM_API int write_short(FILE *, unsigned short *);
GSM_API int write_int(FILE *, unsigned int *);
GSM_API int write_float(FILE *, float *);
GSM_API int write_arbitrary(FILE *, void *, unsigned int);
GSM_API int write_string(FILE *, char *, ...);
GSM_API int invalid_windows_filename(unsigned char *, unsigned short);
GSM_API int missing_file(char *, unsigned short);
GSM_API void set_basename(char *, unsigned short, char **, unsigned short *);
GSM_API void ignore_comments(char *);
GSM_API int null_line(char *);
#ifndef _MSC_VER
int read_string(char *, char *, ...);
#endif

#endif

