#ifndef POSITION_H
#define POSITION_H
#include <stdlib.h>

GSM_API struct position **alloc_positions(unsigned short);
GSM_API struct position **alloc_more_positions(unsigned short, unsigned short, struct position **);
GSM_API struct position *alloc_position();
GSM_API void cleanup_positions(unsigned short, struct position **);
GSM_API int find_positions(struct gsm *);
GSM_API int parse_position(struct gsm *, unsigned short, struct position *, unsigned short);
GSM_API int write_positions(struct gsm *);
GSM_API int calculate_position_matrices(struct gsm *, unsigned short, struct position *);

struct position {
  unsigned int offset;
  int old_id;
  unsigned short bone_id;
  vector_t local; /* was position (nuked by ANSI requirements) */
  vector_t world; /* world co-ordinates */
};

#endif
