#ifndef SKELETON_H
#define SKELETON_H
#include "data.h"
#include <stdlib.h>

GSM_API struct skeleton **alloc_skeletons(unsigned short);
GSM_API struct skeleton *alloc_skeleton();
GSM_API void cleanup_skeletons(unsigned short, struct skeleton **, unsigned short);
GSM_API struct skeleton **make_swt_skeletons();
GSM_API struct skeleton **make_kid_skeletons();
GSM_API struct skeleton **make_tac_skeletons();
GSM_API struct skeleton **make_bf1_skeletons();
GSM_API int find_skeletons(struct gsm *);
GSM_API int parse_skeleton(struct gsm *, unsigned short, struct skeleton *, unsigned short);
GSM_API int write_skeletons(struct gsm *);
GSM_API int get_bone_id_by_animated_bone_entry(struct gsm *, unsigned short);
GSM_API int describe_skeletons(struct gsm *);

struct skeleton {
  unsigned short number;
  off_t offset;
  unsigned short name_length;
  char *name;
  unsigned short num_bones;
  struct bone **bones;
  unsigned short num_animated_bones;
  unsigned short **animated_bones;
  unsigned short num_events;
};

#endif
